#!/usr/bin/env python
""" Provide functionality for a C extension model

	WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
 	         DO NOT MODIFY THIS FILE, MODIFY elliptical_cylinder.h
 	         AND RE-RUN THE GENERATOR SCRIPT

    @author: Mathieu Doucet / UTK
    @contact: mathieu.doucet@nist.gov
"""

from sans.models.BaseComponent import BaseComponent
from sans_extension.c_models import CEllipticalCylinderModel
import copy    
    
class EllipticalCylinderModel(CEllipticalCylinderModel, BaseComponent):
    """ Class that evaluates a EllipticalCylinderModel model. 
    	This file was auto-generated from elliptical_cylinder.h.
    	Refer to that file and the structure it contains
    	for details of the model.
    	List of default parameters:
         scale           = 1.0 
         r_minor         = 20.0 A
         r_ratio         = 1.5 A
         length          = 400.0 A
         contrast        = 3e-006 A-2
         background      = 0.0 cm-1
         cyl_theta       = 1.57 rad
         cyl_phi         = 0.0 rad
         cyl_psi         = 0.0 rad

    """
        
    def __init__(self):
        """ Initialization """
        
        # Initialize BaseComponent first, then sphere
        BaseComponent.__init__(self)
        CEllipticalCylinderModel.__init__(self)
        
        ## Name of the model
        self.name = "EllipticalCylinderModel"
        self.description= """"""""
		## Parameter details [units, min, max]
        self.details = {}
        self.details['scale'] = ['', None, None]
        self.details['r_minor'] = ['A', None, None]
        self.details['r_ratio'] = ['A', None, None]
        self.details['length'] = ['A', None, None]
        self.details['contrast'] = ['A-2', None, None]
        self.details['background'] = ['cm-1', None, None]
        self.details['cyl_theta'] = ['rad', None, None]
        self.details['cyl_phi'] = ['rad', None, None]
        self.details['cyl_psi'] = ['rad', None, None]

   
    def clone(self):
        """ Return a identical copy of self """
        obj = EllipticalCylinderModel()
        obj.params = copy.deepcopy(self.params)
        return obj   
   
    def run(self, x = 0.0):
        """ Evaluate the model
            @param x: input q, or [q,phi]
            @return: scattering function P(q)
        """
        
        return CEllipticalCylinderModel.run(self, x)
   
    def runXY(self, x = 0.0):
        """ Evaluate the model in cartesian coordinates
            @param x: input q, or [qx, qy]
            @return: scattering function P(q)
        """
        
        return CEllipticalCylinderModel.runXY(self, x)
   
# End of file
